// ==UserScript==
// @name		eRepublik Plus OperaMod
// @version		0.59 OpMod
// @description	eRepublik script that simplifies common tasks - Opera Modded Version
// @author		eCitizen PeeKaBooh (original), F@zi (OperaMod)
// @namespace	eCitizenPeeKaBooh
// @include     http://ww*.erepublik.com/*
// @include     http://economy*.erepublik.com/*
// @require		http://jqueryjs.googlecode.com/files/jquery-1.3.1.min.js
// @require     http://www.prototypejs.org/assets/2008/9/29/prototype-1.6.0.3.js
// ==/UserScript==

// eRepublik Plus OperaMod version:
// requires http://my.opera.com/community/forums/topic.dml?id=155224&abc=&page=1&skip=0&show=&perscreen=50
// and enabling 'opera:config#UserPrefs|Exceptions Have Stacktrace'

/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// ===============================================================================
// You are welcome to donate eRepublik in-game gold to authors of this script. 
// Amount of gold is up to you and it reflects what you think authors deserves for
// the effort of contributing to the eRepublik community.
// 
// Use on your own responsibility.
// ===============================================================================

var STRINGS =
{
    SWAP_CURRENCIES: 'Swap currencies',
    LINK: 'Link',
    BOLD: 'Bold',
    ITALIC: 'Italic',
    UNDERLINE: 'Underline',
    SIZE: 'Size',
    IMAGE: 'Image',
    CURRENT_DAMAGE_FULL: 'Current Damage (Full)',
    BARE_HANDED: 'Bare handed',
    WEAPON_QUALITY_LEVEL: 'Weapon Quality Level ',
    TOP_RATED_NEWS: 'Top rated news',											//	10
    LATEST_NEWS: 'Latest news',
    MILITARY_NEWS: 'Military news',
    PLEASE_ENTER: 'Please enter ',
    QUICK_LINKS: 'Quick Links&nbsp;&nbsp;&nbsp;',
    ALL_COMMENTS_AND_TRANSLATE_TO: 'All comments and Translate to&nbsp;&nbsp;&nbsp;',
    INTERACTIVE_MAP: 'Interactive Map',
    NEWS_DESCRIPTION: 'News description',
    THIRD_PARTY_TOOLS_AND_NATIONAL_PAGES_AND_FORUMS: '"Third Party Tools" and "National Pages and Forums"',
    WELLNESS_CALCULATOR_ON_YOUR_PROFILE: 'Wellness calculator on your profile',
    NEWSPAPER_AND_FORUM_ARTICLE_EDITOR: 'Newspaper and Forum Article Editor',						//	20
    ARMY_PAGE_DISPLAYS_DAMAGE_WITH_VARIOUS_QUALITY_OF_WEAPON: 'Army page displays damage with various quality of weapon',
    JOB_MARKET_FILTERING: 'Job market filtering ',
    MM_SWAP_CURRENCIES_LINK: 'Monetary market "Swap currencies" link',
    UNIT_PRICE_OF_PRODUCTS_AND_RAW_MATERIALS: 'Unit price of Products and Raw Materials',
    SEND_MESSAGE_AND_OFFER_GIFTS_ON_EMPLOYEES: 'Send message and/or offer gifts on Employees page',
    SAVE_LINKS: 'Save Links&nbsp;&nbsp;&nbsp;',
    ENABLED: 'Enabled',
    DISABLED: 'Disabled',
    NUM: 'Num',
    CAPTION: 'Caption',													//	30
    LINK: 'Link',
    NEW_WINDOW: 'New window',
    THIRD_PARTY_TOOLS: 'Third Party Tools',
    NATIONAL_PAGES_AND_FORUMS: 'National Pages and Forums',
    PLUS_SETTINGS: 'Plus Settings',
    _ALL_: ' (All) ',
    TRANSLATE_TO: ' Translate to ',
    QUALITY_OF_HOSPITALS_ON_SOCIAL_STATS: 'Quality of Hospitals on Social Stats',
    NEXT_SUPER_SOLDIER_MEDAL_CALCULATOR: 'Next Super Soldier Medal Calculator',
    TRAININGS_TO_NEXT_MEDAL: 'Trainings to next medal: ',								//	40
    SALARIES_AND_MARKET_PRICES_IN_GOLD: 'Salaries and Market Prices in Gold',
    UNDO_TRANSLATE: ' Undo translate',
    ALL_DONATIONS: 'All donations',
    OFFER_A_GIFT: 'Offer a gift',
    SEND_MESSAGE: 'Send message',
    YOU_CANNOT_OFFER_A_GIFT_TO_YOURSELF: 'You cannot offer a gift to yourself.',
    FIGHTS: 'Fights',
    STATS: 'Stats',
    STATS_ON_BATTLE_PAGE: 'Stats on Battle Page',
    TRANSLATING: 'Translating...',                                           //  50
    FAST_ITEMS_PUT_AND_DONATE_LIST_CLEARING_BUTTONS_ON_DONATION_PAGE: 'Fast Items Put and Donate List Clearing Buttons on Donation Page',
    PUT_ITEMS_INTO_DONATE_LIST: 'Put items into donate list',
    CLEAR: 'Clear',
    SHOW_EMPLOYEES_SALARIES_IN_GOLD: 'Show Employees Salaries in Gold',
    IMPORT_SETTINGS: 'Import Settings',
    EXPORT_SETTINGS: 'Export Settings',
    RESET_SETTINGS: 'Reset Settings',
    ARE_YOU_SURE_YOU_WANT_RESET_SETTINGS: 'Are you sure you want reset settings?',
    COPY_TEXT_FROM_THE_FIELD_BELOW: 'Copy text from the field below.',
    PASTE_EXPORTED_DATA: 'Paste exported data',                                      //  60
    RESET_OF_SAVED_LINKS_FINISHED_SUCCESSFULLY: 'Reset of Saved Links finished successfully!',
    IMPORT_SUCCESSFULL: 'Import successfull',
    IMPORT_FAILED: 'Import failed',
    SHOW_PLAYER_LINKS_ON_BATTLEFIELD: 'Show Player Links on Battlefield',
    ITEMS: 'Items',
};

var nationalForums =
[
    {country: 'Venezuela', 			url: 'http://erepublik.ath.cx/', 					name: 'Erepublik Venezuela'},
    {country: 'Uruguay', 			url: 'http://erepublikuy.forosactivos.com/', 		name: 'eRepublik eUruguay'},
    {country: 'USA', 				url: 'http://eusforum.com/', 						name: 'Discussion Forum of the eUnited States of America - Index'},
    {country: 'United-Kingdom', 	url: 'http://forums.erepublik.co.uk/', 				name: 'eRepublik UK &bull; Index page'},
    {country: 'Ukraine',			url: 'http://eRepublik.in.ua/', 					name: 'eRepublik.in.UA - форум онлайн игры eRepublik - Index page'},
    {country: 'Turkey',				url: 'http://www.erepublik.gen.tr', 				name: 'Erepublik Türkiye &bull; Pano anasayfası'},
    {country: 'Sweden', 			url: 'http://www.erepublik.se/', 					name: 'Erepublik.se - Index page'},
    {country: 'Spain', 				url: 'http://erepublikspain.superforos.com/', 		name: 'Foro Erepublik eEspaña :: Indice'},
    {country: 'South-Africa',		url: 'http://z6.invisionfree.com/eSouth_Africa/',	name: 'Log In'},
    {country: 'Slovenia', 			url: 'http://www.erepublik.si/', 					name: 'Erepublik.si - Dobrodošli'},
    {country: 'Slovakia', 			url: 'http://eslovensko.forumotion.net', 			name: 'eSlovensko - Portál'},
    {country: 'Singapore',		 	url: 'http://esingapore.50.forumer.com/index.php', 	name: 'eSingapore &bull; Index page'},
    {country: 'Serbia',			 	url: 'http://www.eserbia.iz.rs/index.php', 			name: 'eSerbia | The new world...'},
    {country: 'Russia', 			url: 'http://www.erespublika.ru/forum/', 			name: 'eRepublik • русскоязычное сообщество - Главная страница'},
    {country: 'Romania', 			url: 'http://romaniavirtuala.info/', 				name: 'RomaniaVirtuala.info | Comunitatea romanilor din eRepublik'},
    {country: 'Portugal',		 	url: 'http://www.erepublikpt.com/', 				name: 'eRepublik PT &bull; Índice'},
    {country: 'Poland', 			url: 'http://erepublik.com.pl/', 					name: 'eRepublik.com.PL | Polskie Centrum Erepublik'},
    {country: 'Philippines',		url: 'http://ephilippines.forummotion.com/', 		name: 'ePhilippines'},
    {country: 'Peru',				url: 'http://erepublikperu.foroactivo.com/', 		name: 'Erepublik Peru'},
    {country: 'Paraguay',			url: 'http://eparaguay.foroactivo.com/', 			name: 'Foro gratis : eParaguay'},
    {country: 'Norway',			 	url: 'http://www.erepublik.no/', 					name: 'Erepublik Norge - Index page'},
    {country: 'Netherlands', 		url: 'http://www.enetherlands.nl/', 				name: 'De Verenigde Nederlanden / The United Netherlands &bull; Portal'},
    {country: 'Mexico', 			url: 'http://erepublikmx.athoim.com/', 				name: 'Official Forum of Mexico. &bull; Página principal'},
    {country: 'Japan', 				url: 'http://nipponblog.net/forum/', 				name: 'eJapan National Forum &bull; Index page'},
    {country: 'Italy', 				url: 'http://www.eitalyforum.altervista.org ', 		name: 'eITALY Community &bull; Indice'},
    {country: 'Israel',				url: 'http://erandia.net/tjc/index.php', 			name: 'Official Israeli Forum - Index'},
    {country: 'Ireland', 			url: 'http://forum.erepublik-ie.com/', 				name: 'eIreland Official Forums &bull; Index page'},
    {country: 'Iran', 				url: 'http://erepublik.ir/forum/', 					name: 'eRepublik.ir - صفحه اصلی'},
    {country: 'Indonesia',		 	url: 'http://www.erepublikindonesia.com/',			name: 'ERepublik Indonesia &bull; Index page'},
    {country: 'India', 				url: 'http://forum.erepublikindia.com/', 			name: 'eIndian Forums &bull; Index page'},
    {country: 'Hungary', 			url: 'http://erepublikhu.info/', 					name: 'Köszöntjük weblapunkon'},
    {country: 'Greece', 			url: 'http://egreece.forumotion.com/', 				name: 'eGreece'},
    {country: 'Germany', 			url: 'http://www.egermany.de.vu/', 					name: 'eGermany Board - www.eRepublik.com'},
    {country: 'France', 			url: 'http://forum.erepublik.fr/', 					name: 'forum.eRepublik.fr &bull; Forum de l’eFrance'},
    {country: 'Finland', 			url: 'http://www.erepublik.fi/', 					name: 'eRepublik.fi &bull; Index page'},
    {country: 'Estonia', 			url: 'http://www.foorum.e-eesti.eu/',				name: 'eEesti foorum &bull; Index page'},
    {country: 'Denmark', 			url: 'http://www.erepublik.dk/', 					name: 'Erepublik.dk - Index page'},
    {country: 'Croatia', 			url: 'http://www.edomovina.com/', 					name: 'eDomovina.com - Službene web stranice eHrvatske'},
    {country: 'Colombia',	 		url: 'http://www.erepublikcolombia.com/', 			name: 'Erepublik Colombia'},
    {country: 'China',				url: 'http://echina.hostei.com/forum/index.php',	name: 'e中国 &bull; Index page'},
    {country: 'Chile',	 			url: 'http://echile.foroactivo.net/', 				name: 'Foro gratis : foro de todos los echile de erepubli'},
    {country: 'Canada', 			url: 'http://ecanada.ws/home.html', 				name: 'eCanada Home'},
    {country: 'Bulgaria',			url: 'http://ebulgaria-forum.info',					name: 'ebulgaria-forum.info - Индек'},
    {country: 'Brazil',				url: 'http://www.erepublikbrasil.com/',				name: 'Erepublik Brasil'},
    {country: 'Bosnia-Herzegovina',	url: 'http://ebih.niceboard.net/forum.htm',			name: 'Free forum : eBosna i Hercegovina'},
    {country: 'Bolivia',			url: 'http://www.erepublikbolivia.com/foro/',		name: 'Foro Oficial de eBolivia - Índice'},
    {country: 'Belgium',			url: 'http://s1.zetaboards.com/eBelgium/index/',	name: 'eBelgium.tk'},
    {country: 'Australia',			url: 'http://www.auserepublik.com/',				name: 'eAustralian eRepublik - Official Website'},
    {country: 'Argentina',			url: 'http://erepublikar.forosactivos.com/',		name: 'Foro Oficial eRepublik Argentina'}
];

/**********************************/
// and here magic begins...

// Add 'missing' trim to the String class
String.prototype.trim = function() { return this.replace(/^\s+|\s+$/g, ''); }

// to avoid jQuery/Prototype/whatever conflicts
var $j = undefined;

// URL Setup
var currURL = location.href;
var arrURL = currURL.split('/');
var BASE_URL = arrURL[0] + '/' + arrURL[1] + '/' + arrURL[2] + '/';

// Constants
var VERSION = '0.59 OperaMod';
var LOCALE = 'en/';
var MAP_URL = 'http://www.eGobba.de/index.htm?nation=';
var RANKS = ['private', 'corporal', 'sergeant', 'lieutenant', 'captain', 'colonel', 'general', 'fieldmarshal'];
var INDUSTRIES = ['', 'Food', 'Gift', 'Weapon', 'Moving Tickets'];
var SKILLS = ['all', 'manufacturing', 'land', 'constructions'];
var TOOLS = ['Badges', 'RSS Feed', 'ThirdParty', 'Forums', 'eRepPlusSettings'];

// Resources (images, strings, etc...)
// modded (F@zi)
var plusImage = '<img src="data:image/gif;base64,\
R0lGODlhsABrAIQSAIsBA6ICA74DCOgZGvJISdhbBdplBd92ENp7M/d1dsSIX9yISumRIPGqLuam\
d8atn/e7O//WSNZdA9ZdA9ZdA9ZdA9ZdA9ZdA9ZdA9ZdA9ZdA9ZdA9ZdA9ZdA9ZdA9ZdAyH5BAEK\
AB8ALAAAAACwAGsAAAX+4CeOZGmeaKqubOu+cCzPdG3feK7vfO//wKBwSCwaj8ikcslsOp/QqHRK\
rVqv2Kx2y+16v+CweEwum8/otHrNbrvf8Lh8Tq/b7/i8fs/v+/+AgYKDhIWGh4iJiouMjY6PkJGS\
k5SVlpeYmZqbnJ2en6ChoqOkpaanqKmqq6ytrq+wsbKztLW2t7i5uru8RQsGC70vCwXFBcItBQYR\
DQXByCkOBQzMztDR0xEMBQ7XKQUH2tzeKODi3TALB8UItObb6CjqzwjGygXtssXnIg4ICOiIGfsF\
rgGECBGKzdoH74NAdh+UGTRQjBqDAwya5Sv1cAFBgCIYjlMGAcK6iNT+Eoq0d0qaAQYU7SncBwFf\
xGU1D9yMUNPcOmMbSdU7aOBAA4QQthmgyNPmO2vrkhZbxuwixWekiB092CAjwm1Da7bzeezD0G3E\
jB5ESLGUtAJcY5oTC1esNGoKzcLVWG8qtWZYQw1FuA6BAopEi5XEd1eliKiO/cVcHBTUW7wFHjgs\
cPQeZa1iQ+IE9wHd2XGkpIVrqxeCxrr4wjIuthWczNVlS5EtrSxCYdj/4KqkXdJ3xQNqwZ4i+1Zq\
8IPFGjdY6trA0Z9rpytDRZZ4sQeDT/ZGWG2admU/8WleHm6dgeoFFHxgei4tg4sy8T00vN5U4+Lb\
WLMZRqz1xY58Diz+IN8I/aEyGE8/LSgCAjEFpoACDzS4gjGjqCaOeh8kIOKICWg4wzQ6jULWApqJ\
SEAAIhAgIwE3cMYAKWRpNiONI+xog404hgOPjyQMYOQAKFEU01LHTCWXMhQ1kKIoTzlwJJIkCHDl\
e2o1YJBJEpWkFAMlGTRlKHMVc2UJWh75npdkStkVZ1KSaZSUap0JCjhSLbBmlgIEKsBeRUFAUUYH\
gGmjoVMZSkp68RkZKJsCBGApXOskWoxRmqJkUFnvGcDRASx+IKgAJVgKAADzmfRBoqIm2imdjJKk\
pymWWkrCqqu2qhOXr5qUVKFGwfSSq6rwyuoIvIoA7LMmkSlmQWUiSskKrwFU2mxIB4jKmU7TUIRc\
ekV1y9oqq+ba6wkckjNECAA7" style="position:relative; left:-25px; top:-75px"/>';

var xChangeImage = '<a id="currency_switch" href="javascript:void(0)" style=\
"display: inline; position:relative; left: 328px; top: -20px;"><img src="' +
BASE_URL + 'images/parts/icon_show-off.gif"/>&nbsp;&nbsp;' + 
STRINGS['SWAP_CURRENCIES'] + '</a>';

var linkButton = '<br/><span style="font-size: 12px; border: 1px solid darkg\
rey; padding: 5px 15px; cursor: pointer" class="rightpadded padded" id="add_\
link2">' + STRINGS['LINK'] + '</span>';

var boldButton = '<span style="font-size: 12px; font-weight: bold; border: 1\
px solid darkgrey; padding: 5px 15px; cursor: pointer" class="rightpadded pa\
dded" id="add_bold2">' + STRINGS['BOLD'] + '</span>';

var italicButton = '<span style="font-size: 12px; font-style: italic; border\
: 1px solid darkgrey; padding: 5px 15px; cursor: pointer" class="rightpadded\
padded" id="add_italic">' + STRINGS['ITALIC'] + '</span>';

var underlineButton = '<span style="font-size: 12px; text-decoration: underl\
ine; border: 1px solid darkgrey; padding: 5px 15px; cursor: pointer" class="\
rightpadded padded" id="add_underline">' + STRINGS['UNDERLINE'] + '</span>';

var sizeButton = '<span style="font-size: 12px; border: 1px solid darkgrey; \
padding: 5px 15px; cursor: pointer" class="rightpadded padded" id="add_size"\
>' + STRINGS['SIZE'] + '</span>';

var imageButton = '<span style="font-size: 12px; border: 1px solid darkgrey;\
padding: 5px 15px; cursor: pointer" class="rightpadded padded" id="add_imag\
e">' + STRINGS['IMAGE'] + '</span><br/>';

var languages = [
    {l: 'Albanian', s: 'sq'},
    {l: 'Arabic', s: 'ar'},
    {l: 'Bulgarian', s: 'bg'},
    {l: 'Chinese', s: 'zh'},
    {l: 'Chinese_simplified', s: 'zh-cn'},
    {l: 'Chinese_traditional', s: 'zh-tw'},
    {l: 'Croatian', s: 'hr'},
    {l: 'Czech', s: 'cs'},
    {l: 'Danish', s: 'da'},
    {l: 'Dutch', s: 'nl'}, 
    {l: 'English', s: 'en'},
    {l: 'Estonian', s: 'et'},
    {l: 'Filipino', s: 'tl'},
    {l: 'Finnish', s: 'fi'},
    {l: 'French', s: 'fr'},
    {l: 'Galician', s: 'gl'},
    {l: 'German', s: 'de'},
    {l: 'Greek', s: 'el'},
    {l: 'Hebrew', s: 'iw'},
    {l: 'Hindi', s: 'hi'},
    {l: 'Hungarian', s: 'hu'},
    {l: 'Indonesian', s: 'id'},
    {l: 'Italian', s: 'it'},
    {l: 'Japanese', s: 'ja'},
    {l: 'Korean', s: 'ko'},
    {l: 'Latvian', s: 'lv'},
    {l: 'Lithuanian', s: 'lt'},
    {l: 'Maltese', s: 'mt'},
    {l: 'Norwegian', s: 'no'},
    {l: 'Polish', s: 'pl'},
    {l: 'Portuguese', s: 'pt-pt'},
    {l: 'Romanian', s: 'ro'},
    {l: 'Russian', s: 'ru'},
    {l: 'Serbian', s: 'sr'},
    {l: 'Slovak', s: 'sk'},
    {l: 'Slovenian', s: 'sl'},
    {l: 'Spanish', s: 'es'},
    {l: 'Swedish', s: 'sv'},
    {l: 'Thai', s: 'th'},
    {l: 'Turkish', s: 'tr'},
    {l: 'Ukrainian', s: 'uk'},
    {l: 'Vietnamese', s: 'vi'}
];

var cID = '';
var tempList = null;
var erepPlusUtils = undefined;
var erepPlusSettings = undefined;
var debug = undefined;

function showPotentialDamage()
{
    var wellness = $j("#wellnessvalue").text().trim();
    var strenght = $j("#content table td:eq(1)").text().trim();
    var rank = $j("#content table td:eq(3) img").attr("src").split('_')[3].split('.')[0];
    var rankBonus = (RANKS.indexOf(rank) + 1) * 0.2 + 1;
    var BaseDamage = 2 * (1 + (wellness - 25) / 100) * strenght * rankBonus;
    var BaseDamageFull = 3.5 * strenght * rankBonus; 

    var htmlDamage = '<tr><td valign="middle" nowrap="nowrap">' + STRINGS['CURRENT_DAMAGE_FULL'] + '</td>';
    htmlDamage += '<td valign="middle">';
    htmlDamage += '<a alt="' + STRINGS['BARE_HANDED'] + '" title="' + STRINGS['BARE_HANDED'] +'" href="/' + LOCALE + 'market/country-0-industry-' + INDUSTRIES.indexOf('Weapon') + '-quality-0">';
    htmlDamage += '<span class="qlsmallmeter" style="float: left; height: 15px; vertical-align: middle; margin-right: 14px">';
    htmlDamage += '<span class="qlsmalllevel" width: 0%">';
    htmlDamage += '</span></span></a><strong>' + Math.ceil(BaseDamage / 2) + ' ('+ (Math.ceil(BaseDamageFull / 2)) +')</strong><br/>';

    for(i=1; i<=5; i++)
    {
        htmlDamage += '<a onclick="location.href = this.href;" style="background-color: red" alt="' + STRINGS['WEAPON_QUALITY_LEVEL'] + i + '" title="' + STRINGS['WEAPON_QUALITY_LEVEL'] + i + '" href="/' + LOCALE + 'market/country-0-industry-' + INDUSTRIES.indexOf('Weapon') + '-quality-' + i + '">';
        htmlDamage += '<span class="qlsmallmeter" style="float: left; height: 15px; line-height: 15px; vertical-align: middle; margin-right: 14px">';
        htmlDamage += '<span class="qlsmalllevel" style="width: ' + (i * 2) + '0%">';
        htmlDamage += '<img style="padding-bottom: 1px" src="/images/parts/qlsmall-indicator_full.gif" />';
        htmlDamage += '</span></span></a><strong>' + Math.ceil(BaseDamage * (i / 5 + 1)) + ' ('+ (Math.ceil(BaseDamageFull * (i / 5 + 1))) + ')</strong><br/>';
    }

    htmlDamage += '</td></tr>';
    htmlDamage = $j("#content table tbody").html() + htmlDamage;
    $j("#content table tbody").html(htmlDamage);
}

function updateSavedLinks()
{
    var updateData =
    [
        {c: erepPlusSettings.LINK_MARKET,       el: '#menu3 li a[href*=/market]',            p: /^market/},
        {c: erepPlusSettings.LINK_MON_MARKET,   el: '#menu3 li a[href*=/exchange]',          p: /^exchange/},
        {c: erepPlusSettings.LINK_JOB_MARKET,   el: '#menu3 li a[href*=/human-resources]',   p: /^human/},
        {c: erepPlusSettings.LINK_COM_MARKET,   el: '#menu3 li a[href*=/companies-for-sale]',p: /^companies/},
        {c: erepPlusSettings.LINK_RANKINGS,     el: '#menu4 li a[href*=/rankings]',          p: /^ranking/},
        {c: erepPlusSettings.LINK_COUNTRY,      el: '#menu4 li a[href*=/country]',           p: /^country\//},
      /*{c: erepPlusSettings.LINK_COUNTRY_ECO,  el: '#menu4 li:eq(2) a',                     p: /^country\/econ/},
        {c: erepPlusSettings.LINK_COUNTRY_POL,  el: '#menu4 li:eq(3) a',                     p: /^country\/poli/},
        {c: erepPlusSettings.LINK_COUNTRY_MIL,  el: '#menu4 li:eq(4) a',                     p: /^country\/mili/},*/
        {c: erepPlusSettings.LINK_ELECTIONS,    el: '#menu5 li a[href*=/elections]',         p: /^election/},
        {c: erepPlusSettings.LINK_TOOLS,        el: '#menu5 li a[href*=/badges]',            p: /^badges/},
        {c: erepPlusSettings.LINK_TOOLS,        el: '#menu5 li a[href*=/rss_menu]',          p: /^rss_menu/},
        {c: erepPlusSettings.LINK_NEWS,         el: '#menu5 li a[href*=/news]',              p: /^news\//}
    ];
    
    var currURL = location.href;
    var token = currURL.substr(BASE_URL.length);
    
    updateData.forEach(function(v)
    {
        if(v.p.test(token))
            erepPlusSettings.setValue(v.c, currURL);
    });
    
    var tmp = undefined;
    updateData.forEach(function(v)
    {
        tmp = erepPlusSettings.getValue(v.c)
        if(tmp != undefined)
            $j(v.el).attr("href", tmp);
    });
}

function addJobMarketLinks()
{
    var currURL = location.href.split('/');
    var skillURL = currURL[5].split('-');
    
    var skillsLinks =
    [
        {t: 'img:eq(0)', t2: 'p:eq(0)', l: SKILLS[1]},
        {t: 'img:eq(1)', t2: 'p:eq(1)', l: SKILLS[2]},
        {t: 'img:eq(2)', t2: 'p:eq(2)', l: SKILLS[3]}
    ];
    skillsLinks.forEach(function (p)
    {
        skillURL[3] = p.l;
        skillURL[5] = 0;
        currURL[5] = skillURL.join('-');
        $j("div.rightfilters " + p.t).wrap('<a class="linkhighlight" href="/' + LOCALE + 'human-resources/' + currURL[5] + '"></a>');
        var currSkill = Math.floor($j("div.rightfilters " + p.t2).text());
        currSkill += 1;
        currSkill = (currSkill > 8) ? 8 : currSkill;
        skillURL[5] = currSkill;
        currURL[5] = skillURL.join('-');
        $j("div.rightfilters " + p.t2).wrap('<a class="linkhighlight" href="/' + LOCALE + 'human-resources/' + currURL[5] + '"></a>');
    });
}

function addSalaryInGold()
{
    var currency = $j("table.offers tr:eq(1) td:eq(3) span.currency").text();
    if(currency=='')
        return;
    var sReq = "http://api.erepublik.com/v1/feeds/exchange/GOLD/" + currency + ".json";
    
    erepPlusUtils.xmlHttpRequest(
    {
        method: 'GET',
        operaHack: true,
        url: sReq,
        onload: function(json)
        {
            try
            {
                eval("jsonObj = " + json.responseText);
            }
            catch(e)
            {
                return;
            }
            
            var rate = jsonObj[0]["offer"]["for"];
            var salary = 0;
            var goldSalary = 0;

            $j("table.offers tr:eq(0) th:eq(2)").attr("width", "70");
            $j("table.offers tr:eq(0) th:eq(2)").after("<th width='80'><img title='Gold' alt='Gold' src='/images/parts/icon-gold.gif'/></th>");
            $j("table.offers tr").each(function(i)
            {
                if(i!=0)
                {
                    $j(this).find("td:eq(2)").attr("width", "70");
                    salary = $j(this).find("td:eq(3) span:eq(0)").text() + $j(this).find("td:eq(3) sup").text();
                    goldSalary = Math.round(parseFloat(salary) / parseFloat(rate) * 10000) / 10000;
                    $j(this).find("td:eq(2)").after("<td>" + erepPlusUtils.formatGoldValue(goldSalary) + "</td>");
                }
            });
        }
    });
}

function addNewsTitle()
{
    var currURL = location.href.split('/');
    var newsDesc = '';
    
    switch (currURL[5])
    {
        case 'rated':
        case undefined:
            newsDesc = STRINGS['TOP_RATED_NEWS'];
            break;
        case  'latest':
            newsDesc = STRINGS['LATEST_NEWS'];
            break;
        case 'military':
            newsDesc = STRINGS['MILITARY_NEWS'];
            break;
    }
    
    try {
        var flashVars = null;
        if(typeof(window.opera) == 'undefined')
        {
            flashVars = $j("h1 embed").attr("flashvars");
            flashVars = flashVars.replace("txt=News", "txt=" + newsDesc);
            $j("h1 embed").attr("flashvars", flashVars);
        }
        else
        {
            flashVars = $j("h1 object param:eq(3)").attr("value");
            flashVars = flashVars.replace("txt=News", "txt=" + newsDesc);
            $j("h1 object param:eq(3)").attr("value", flashVars);
        }
        $j("h1 span").text(newsDesc);
        $j("h1").clone().replaceAll("h1");

    }
    catch(err)
    {
        $j("h1").text(newsDesc);
    }
}

function fixMonetaryMarket()
{
    if(typeof unsafeWindow.$j == 'undefined')
        window.setTimeout(fixMonetaryMarket, 100);
    else
    {
        unsafeWindow.$j("body").ajaxSuccess(function(ev, request, settings)
        {
            if(erepPlusSettings.getSetting(10) == '1')
                window.setTimeout(updateSavedLinks, 100);
                
            window.setTimeout(function()
            {
                var sell_currency = $j('#sell_currency').val();
                var buy_currency = $j('#buy_currency').val();
                
                if($j("#sell_currencies_selector a[id='" + buy_currency + "']").size() != 0)
                {
                    var newLink = $j("a[href*='/" + LOCALE + "exchange/create']").attr("href");
                    newLink = newLink.replace(/#buy_currencies=(\d+)/, '#buy_currencies=' + sell_currency);
                    newLink = newLink.replace(/;sell_currencies=(\d+)/, ';sell_currencies=' + buy_currency);
                    $j("a[href*='/" + LOCALE + "exchange/create'].postoff").attr("href", newLink);
                
                    if(settings.url.match(/selectAccount/) && !settings.url.match(/listMyOffers/))
                    {
                        {
                            $j("#filters").append(xChangeImage);
                            $j("#currency_switch").attr("href", "#buy_currencies=" + sell_currency + ";sell_currencies=" + buy_currency + ";page=1");
                        }
                    }
                }
            }, 100);
        });	
    }
}

function enableQuickDonate()
{
    var MAXITEMS = 10;
    
    var pid = 0;
    var clearFunc = function()
    {
        $j("#big li.sortItem").each(function(i)
        {
            $j("#small").append($j(this));
        });
    };
    
    var lastSelectedPutSize = erepPlusSettings.getValue(erepPlusSettings.DONATE_PUTSIZE);
    if(lastSelectedPutSize == undefined)
        lastSelectedPutSize = MAXITEMS;
    
    var htmlDonate = '<span style="margin-left: 20px; cursor: pointer" tabindex="0" id="erepplus_donate_load" class="dotted">'+STRINGS['PUT_ITEMS_INTO_DONATE_LIST']+'</span>';
    htmlDonate += '<span style="margin-left: 20px;"><select id="erepplus_donate_putsize">';
    for(var i=1; i<=MAXITEMS; i++)
    {
        htmlDonate += '<option value="'+i+'"';
        if(i==lastSelectedPutSize)
            htmlDonate += ' selected="selected"'
        htmlDonate += '>'+i+'</option>';
    }
    
    htmlDonate += '</select>&nbsp;'+STRINGS['ITEMS']+'</span>';
    
    htmlDonate += '<span style="margin-left: 20px; cursor: pointer" tabindex="0" id="erepplus_donate_clear" class="dotted">' + STRINGS['CLEAR'] + '</span>';
    
    $j("#donationlink").before(htmlDonate);
    
    $j("#erepplus_donate_putsize").change(function()
    {
        erepPlusSettings.setValue(erepPlusSettings.DONATE_PUTSIZE, $j(this).attr('value'));
    });
    
    $j("#erepplus_donate_load").click(function()
    {
        clearFunc();
        var maxput = Math.min(erepPlusSettings.getValue(erepPlusSettings.DONATE_PUTSIZE), $j("#available_items").attr('value'));
        $j("#small li.sortItem").each(function(i)
        {
            if(i==maxput)
                return false;

            $j("#big").append($j(this))
        });
    });
    
    $j("#erepplus_donate_clear").click(clearFunc);
}

function showEmployeeMessageAndGifts()
{
    var empArray = new Array();
    var citizenID = 0;
    
    $j("div.ctools h2").after('<div id="messagealert" style="display:none;"><p class="regular"></p></div>');

    $j("table.employees_details tr").each(function(i)
    {
        if(i > 0)
        {
            citizenID = $j(this).find("td:eq(0) div div:eq(0) a").attr("hreF").match(/\/citizen\/profile\/(\d+)/)[1];
            var where = $j(this).find("span.tdots2");
            if(where.html() == null)
                where = $j(this).find("td:eq(0) div div:eq(2)");
            else
                where = where.parent();
            
            where.append('<br/><a title="' + STRINGS['SEND_MESSAGE'] + '" href="/' + LOCALE + 'messages/compose/' + citizenID + '"><img alt="' + STRINGS[45] + '" src="/images/parts/btn-icon_send-message.gif"></a>');
            where.append('<a id="donate_link_' + citizenID + '" style="position: relative; top: 5px; display: inline" title="' + STRINGS['OFFER_A_GIFT'] + '" href="javascript:void(0);"><img alt="' + STRINGS[44] + '" src="/images/parts/icon_industry_gift.gif" width="25px" height="25px">').click(function() {
                var citID = $j(this).find("a:eq(0)").attr("hreF").match(/\/citizen\/profile\/(\d+)/)[1];
                $j('#donate_link_' + citID).hide('fast');
                jQuery.post(
                    '/citizen/offergift/'+citID,
                    {
                        _token: $j("#_token").val(),
                        id:     citID
                    },
                    function (data, textStatus) {
                        var pp = 1;
                        if(data.donated.status == "false") {
                            $j("#messagealert").css("display", "block");
                            $j("#messagealert").attr("class","invalidicon");
                        } else if(data.donated.status == "true") {
                            $j("#messagealert").css("display","none").fadeIn('fast');
                            $j("#messagealert").css("display","block");
                            $j("#messagealert").attr("class","validicon success_message");
                        } else if(data.donated.status == "captcha") {
                            document.location = data.donated.back_url;
                            pp = 0;
                        }
                        else {
                            $j("#messagealert").css("display", "block");
                            $j("#messagealert").attr("class","invalidicon");
                            data.donated.message = STRINGS['YOU_CANNOT_OFFER_A_GIFT_TO_YOURSELF'];
                        }
                        if(pp == 1) {
                            $j('#donate_link_' + citID).show().css('display', 'inline');
                            $j("#messagealert").children("p").html(data.donated.message);
                        }
                    },
                    "json"
                );
            });
        }
    });
}

function showEmployeeSalariesInGold()
{
    var currency = '';
    var salary = 0;
    var goldSalary = 0;
    var sReq = '';
    
    var rates = new Object(); // it will probably contain only one elements but who knows...
    $j("span.currency").each(function()
    {
        currency = $j(this).text();
        rates[currency] = 0;
    });
    
    for(currency in rates)
    {
        sReq = 'http://api.erepublik.com/v1/feeds/exchange/' + currency + '/GOLD.json';
        erepPlusUtils.xmlHttpRequest(
        {
            method: 'GET',
            operaHack: true,
            url: sReq,
            onload: function(json)
            {
                try
                {
                    eval("jsonObj = " + json.responseText);
                }
                catch(e)
                {
                    return;
                }
                rates[currency] = jsonObj[0]["offer"]["for"];
                
                $j("table.employees_details td.e_salary:has(span.currency:contains("+currency+"))").each(function(i)
                {
                    salary = $j(this).find(".special").text() + $j(this).find("sup:eq(0)").text();
                    goldSalary = Math.round(parseFloat(salary) * parseFloat(rates[currency]) * 10000) / 10000;
                    
                    $j(this).append('<br/><span class="rightpadded"><span style="color: #5FAE34;">' + erepPlusUtils.formatGoldValue(goldSalary) + '</span></span>');
                });
            }
        });
    }
}

function showUnitPrice()
{
    var industryIndex = location.href.split('/')[5].split('-')[3];
    var unitPrice = 0;
    var price = 0;
    var quality = 0;
    
    $j("table.offers tr").each(function(i) {
        if(i != 0) 
        {
            quality = $j(this).find("td:eq(1) span span").css("width");
            quality = quality.substr(0, quality.length - 1) / 20;
            price = $j(this).find("td:eq(3) span:eq(0)").text() + $j(this).find("td:eq(3) sup").text(); 
            if(quality > 1)
            {
                price = $j(this).find("td:eq(3) span:eq(0)").text() + $j(this).find("td:eq(3) sup").text(); 
                unitPrice = (Math.round((price / quality) * 1000) / 1000).toString().split('.');
                if(unitPrice[1] == undefined)
                    unitPrice[1] = '';
                else
                    unitPrice[1] = '.' + unitPrice[1];
                $j(this).find("td:eq(3) span:eq(1)").after('<br/><span class="special" style="color: #5FAE34;">' + unitPrice[0] + '</span><sup style="color: #5FAE34;">' + unitPrice[1] + '</sup><span class="special"></span>');
            }
        }
    });
}

function showMarketPricesInGold()
{
    var currency = $j("table.offers tr:eq(1) td:eq(3) span.currency").text();
    if(currency=='')
        return;
    var sReq = 'http://api.erepublik.com/v1/feeds/exchange/' + currency + '/GOLD.json';

    erepPlusUtils.xmlHttpRequest(
    {
        method: 'GET',
        operaHack: true,
        url: sReq,
        onload: function (json) {
            try
            {
                eval("jsonObj = " + json.responseText);
            }
            catch(e)
            {
                return;
            }
            var rate = jsonObj[0]["offer"]["for"];
            var goldPrice = 0;
            var price = 0;
            var goldUnitPrice = 0;
            var unitPrice = 0;

            $j("table.offers tr:eq(0) th:eq(0)").attr("width", "200");
            $j("table.offers tr:eq(0) th:eq(2)").after("<th width='80'><img title='Gold' alt='Gold' src='/images/parts/icon-gold.gif'/></th>");
            $j("table.offers tr").each(function(i) {
                if(i != 0) 
                {
                    $j(this).find("td:eq(0)").attr("width", "200");
                    quality = $j(this).find("td:eq(1) span span").css("width");
                    quality = quality.substr(0, quality.length - 1) / 20;
                    
                    price = $j(this).find("td:eq(3) span:eq(0)").text() + $j(this).find("td:eq(3) sup:eq(0)").text(); 
                    goldPrice = Math.round(parseFloat(price) * parseFloat(rate) * 10000) / 10000;
                    $j(this).find("td:eq(2)").after("<td>" + erepPlusUtils.formatGoldValue(goldPrice) + "</td>");
                    if(quality > 1 && erepPlusSettings.getSetting(8) == '1')
                    {
                        unitPrice = (Math.round((price / quality) * 1000) / 1000).toString().split('.');
                        if(unitPrice[1] == undefined)
                            unitPrice[1] = '';
                        else
                            unitPrice[1] = '.' + unitPrice[1];
                            
                        goldUnitPrice = Math.round(parseFloat(price) / quality * parseFloat(rate) * 10000) / 10000;
                        $j(this).find("td:eq(3)").append('<br/><span style="color: #5FAE34;">' + erepPlusUtils.formatGoldValue(goldUnitPrice) + '</span>');
                        //$j(this).find("td:eq(3) span:eq(1)").after('<br/><span class="special" style="color: #5FAE34;">' + unitPrice[0] + '</span><sup style="color: #5FAE34;">' + unitPrice[1] + '</sup><span class="special"></span>');
                    }
                }
            });
        }
    });
    /*$j(".marketbtn").each(function(i, el)
    {
        $j(this).after(' ('+ 150.50 + ')');
    });*/
}

function addThirdPartyTools()
{
    var thirdPartyTools =
    [
        {aname: 'PeeKaBooh',	aid: '1408159',	name: 'eRepublik Plus',					url: BASE_URL + 'article/erepublik-plus-grand-tutorial-807662/1/20', img: 'http://static.erepublik.com/uploads/avatars/Newspapers/2009/05/15/81f97d040a2b499d539e0a7f61ce3788_55x55.jpg'},
        {aname: 'Sanya18',		aid: '1223208',	name: 'Gecko Ltd eRepublik Tools', 		url: 'http://erepmarket.co.cc/', 					img: 'http://www.erepmarket.co.cc/images/gltd55x55.png'},
        {aname: 'Kumnaa',		aid: '673541', 	name: 'CCCP Group tools',				url: 'http://www.cccp-group.org/', 					img: 'http://images.cccp-group.org/CCCP-55.png'},
        {aname: 'Big Brother',	aid: '557922', 	name: 'eRepublik.ws',					url: 'http://erepublik.ws/', 						img: 'http://static.erepublik.com/uploads/avatars/Newspapers/2008/08/22/e905766ec3489e1a8e2275541ba80c94_55x55.jpg'},
        {aname: 'carbon',		aid: '1124061',	name: 'eRepublik Tools (eRepTools)',	url: 'http://www.ereptools.net/', 					img: 'http://ereptools.net/images/logo_ereptools.png'},
        {aname: 'aVie',			aid: '1288990',	name: 'eGovernment',					url: 'http://www.aviecreative.com/egovernment/', 	img: 'http://static.erepublik.com/uploads/avatars/Newspapers/2009/02/14/9b5707af19283ac1f3620530966f1759_55x55.jpg'},
        {aname: 'Gobba',		aid: '1226399',	name: 'eRepublik Map & Tools',			url: 'http://www.egobba.de/', 						img: 'http://www.egobba.de/images/gobba_link_tiny.jpg'}
    ];

    $j("div.bordersep").hide();
    $j("div.holder").hide();
    $j("a.on").removeClass('on');
    $j("a#third_party_tools").addClass('on');
    
    thirdPartyTools.forEach(function(p)
    {
        var toolItem = '<div class="bordersep"><p>';
        toolItem += '<a target="blank" href="' + p.url + '">'
        
        if(p.img != '')
            toolItem += '<img src="' + p.img + '" class="iconsoft" alt='+p.name+' />';
        
        toolItem += '&nbsp;&nbsp;&nbsp;' + p.name + '</a>'
        
        if(p.aid != '')
            toolItem += ' by <a href="/' + LOCALE + 'citizen/profile/' + p.aid + '">' + p.aname + '</a></p></div>';
        else
            toolItem += p.aname + '</a></p></div>';
        
        $j("ul.tabs").after(toolItem);
    });

    erepPlusSettings.setValue(erepPlusSettings.TOOLS_TABS, TOOLS[2]);
}

function addNationalForums()
{
    $j("div.bordersep").hide();
    $j("div.holder").hide();
    $j("a.on").removeClass('on');
    $j("a#national_forums").addClass('on');
    
    nationalForums.forEach(function(p)
    {
        $j("ul.tabs").after('<div class="bordersep"><p><a target="blank" href="' + p.url + '"><img class="flag" src="/images/flags/L/' + p.country + '.gif" alt="' + p.country.replace(/-/, ' ') + '" title="' + p.country.replace(/-/, ' ') + '"/>' + p.name + '</a></p></div>');
    });

    erepPlusSettings.setValue(erepPlusSettings.TOOLS_TABS, TOOLS[3]);
}

function addeRepPlusSettings()
{
    var htmlSettings = '';
    
    var eRepPlusSettings = [
        {name: STRINGS['SAVE_LINKS'], pos:  10},
        {name: STRINGS['SHOW_EMPLOYEES_SALARIES_IN_GOLD'], pos:  17},
        {name: STRINGS['SEND_MESSAGE_AND_OFFER_GIFTS_ON_EMPLOYEES'], pos:  9},
        {name: STRINGS['UNIT_PRICE_OF_PRODUCTS_AND_RAW_MATERIALS'], pos:  8},
        {name: STRINGS['MM_SWAP_CURRENCIES_LINK'], pos: 7},
        {name: STRINGS['JOB_MARKET_FILTERING'], pos: 6},
        {name: STRINGS['ARMY_PAGE_DISPLAYS_DAMAGE_WITH_VARIOUS_QUALITY_OF_WEAPON'], pos: 5},
        {name: STRINGS['NEWSPAPER_AND_FORUM_ARTICLE_EDITOR'], pos: 4},
        {name: STRINGS['WELLNESS_CALCULATOR_ON_YOUR_PROFILE'], pos: 3},
        {name: STRINGS['THIRD_PARTY_TOOLS_AND_NATIONAL_PAGES_AND_FORUMS'], pos: 2},
        {name: STRINGS['NEWS_DESCRIPTION'], pos: 1},
        {name: STRINGS['INTERACTIVE_MAP'], pos:  11},
        {name: STRINGS['SHOW_PLAYER_LINKS_ON_BATTLEFIELD'], pos: 18},
        {name: STRINGS['NEXT_SUPER_SOLDIER_MEDAL_CALCULATOR'], pos: 14},
        {name: STRINGS['QUALITY_OF_HOSPITALS_ON_SOCIAL_STATS'], pos: 13},
        {name: STRINGS['SALARIES_AND_MARKET_PRICES_IN_GOLD'], pos: 15},
        {name: STRINGS['FAST_ITEMS_PUT_AND_DONATE_LIST_CLEARING_BUTTONS_ON_DONATION_PAGE'], pos:  16},
        {name: STRINGS['ALL_COMMENTS_AND_TRANSLATE_TO'], pos: 0},
        {name: STRINGS['QUICK_LINKS'], pos: 12}
    ];
    
    
    var toggleFeature = function(obj)
    {
        var sett = obj.id.split('_');
        if(erepPlusSettings.getSetting(sett[2]) == '1')
            erepPlusSettings.setSetting(sett[2], 0);
        else
            erepPlusSettings.setSetting(sett[2], 1);
        addeRepPlusSettings();	
    }
    
    $j("div.bordersep").hide();
    $j("div.holder").hide();
    $j("a.on").removeClass('on');
    $j("a#erep_plus_settings").addClass('on');
    
    htmlSettings += '<div class="bordersep">\
        &nbsp;&nbsp;&nbsp;<input type="button" id="erepplus_settings_export" value="'+STRINGS['EXPORT_SETTINGS']+'">\
        &nbsp;&nbsp;&nbsp;<input type="button" id="erepplus_settings_import" value="'+STRINGS['IMPORT_SETTINGS']+'">\
        &nbsp;&nbsp;&nbsp;<input type="button" id="erepplus_settings_reset" value="'+STRINGS['RESET_SETTINGS']+'">\
        </div>';
    
    eRepPlusSettings.forEach(function(p)
    {
        htmlSettings += '<div class="bordersep">';
        if(erepPlusSettings.getSetting(p.pos) == '1')
            htmlSettings += '<div title="' + STRINGS['ENABLED'] + '" id="feature_on_' + p.pos + '" style="cursor: pointer; float: left; height: 25px; width: 25px; background:url(/images/parts/btn-weekly_on.gif) 0 0 no-repeat"></div>';
        else
            htmlSettings += '<div title="' + STRINGS['DISABLED'] + '" id="feature_off_' + p.pos + '" style="cursor: pointer; float: left; height: 25px; width: 25px; background:url(/images/parts/btn-weekly_off.gif) 0 0 no-repeat"></div>';
        htmlSettings += '<div style="float: left; line-height: 25px;">&nbsp;&nbsp;&nbsp;' + p.name + '</div>';
        
        if(p.pos == 0)
        {
            htmlSettings += '<select id="lang_select">';
            languages.forEach(function(p2)
            {
                htmlSettings += '<option value="' + p2.s +'"';
                
                if(erepPlusSettings.getValue(erepPlusSettings.TRANSLATE_LANG) == p2.s)
                    htmlSettings += ' selected="selected"';
                    
                htmlSettings += '>' + p2.l + '</option>';
            });
            htmlSettings += '</select>';
        }
        
        if(p.pos == 12)
        {
            htmlSettings += '<table class="offers"><thead><tr><th style="text-align: center;" width="40">Num</th><th width="150">Caption</th><th width="300">Link</th><th style="text-align: center" width="120">New window</th></tr></thead>';
            htmlSettings += '<tbody>';
            for(var i=0; i<10; i++)
            {
                htmlSettings += '<tr><td style="text-align: center"> ' + i + '</td>';
                htmlSettings += '<td ><input type="text" id="ql_caption_' + i + '" value="' + erepPlusSettings.getQuickLink(i, 0) + '"></td>';
                htmlSettings += '<td><input type="text" size="45" id="ql_url_' + i + '" value="' + erepPlusSettings.getQuickLink(i, 1) +'"></td>';
                if(erepPlusSettings.getQuickLink(i, 2) == '1')
                    htmlSettings += '<td style="text-align: center"><input type="checkbox" id="ql_cb_' + i + '" checked="checked"></td></tr>';
                else
                    htmlSettings += '<td style="text-align: center"><input type="checkbox" id="ql_cb_' + i + '"></td></tr>';
            }
            htmlSettings += '</tbody></table>';
        }
        
        if(p.pos == 10)
        {
            htmlSettings += '<input type="button" id="reset_saved_links" value="Reset saved links" />';
        }
        htmlSettings += '</div>';
    });
    
    $j("ul.tabs").after(htmlSettings);
    $j("div [id^=feature_o]").click(function(){toggleFeature(this);});
    
    $j("#lang_select").change(function(){erepPlusSettings.setValue(erepPlusSettings.TRANSLATE_LANG, $j(this).attr('value'));});
    
    for(var i = 0; i < 10; i++)
    {
        $j("#ql_caption_" + i).change(function(){erepPlusSettings.setQuickLink(this, 0);});
        $j("#ql_url_" + i).change(function(){erepPlusSettings.setQuickLink(this, 1);});
        $j("#ql_cb_" + i).change(function(){erepPlusSettings.setQuickLink(this, 2);});
    }
    
    $j("#reset_saved_links").click(function()
    {
        erepPlusSettings.resetSavedLinks();
        updateSavedLinks();
        location.reload();
        alert(STRINGS['RESET_OF_SAVED_LINKS_FINISHED_SUCCESSFULLY']);
    });
    
    $j("#erepplus_settings_reset").click(function()
    {
        if(confirm(STRINGS['ARE_YOU_SURE_YOU_WANT_RESET_SETTINGS']))
        {
            erepPlusSettings.reset();
            location.reload();
        }
    });
    $j("#erepplus_settings_export").click(function()
    {
        prompt(STRINGS['COPY_TEXT_FROM_THE_FIELD_BELOW'], erepPlusSettings.export());
    });
    
    $j("#erepplus_settings_import").click(function()
    {
        var data = prompt(STRINGS['PASTE_EXPORTED_DATA'], '');
        if(data!=null && data!='' && erepPlusSettings.import(data))
        {
            location.reload();
            alert(STRINGS['IMPORT_SUCCESSFULL']);
        }
        else
        {
            alert(STRINGS['IMPORT_FAILED']);
        }
    });
    
    $j("table.offers").css(
    {
        'width': '570px', 
        'float': 'right',
        'font-size': '12px',
        'padding': '0px 0px'
    });
    $j("table.offers th").css(
    {
        'border-bottom': '1px solid #bebebe',
        'padding': '5px 0px'
    });

    erepPlusSettings.setValue(erepPlusSettings.TOOLS_TABS, TOOLS[4]);
}

function modifyTools()
{
    $j("a[href='/" + LOCALE + "badges']").click(function(){erepPlusSettings.setValue(erepPlusSettings.TOOLS_TABS, TOOLS[0])});
    $j("a[href='/" + LOCALE + "rss_menu']").click(function(){erepPlusSettings.setValue(erepPlusSettings.TOOLS_TABS, TOOLS[1])});
    
    if(erepPlusSettings.getSetting(2)=='1')
    {
        $j("ul.tabs").append('<li><a id="third_party_tools" href="#"><span>' + STRINGS['THIRD_PARTY_TOOLS'] + '</span></a></li>');
        $j("a#third_party_tools").click(function(){addThirdPartyTools()});
    
        $j("ul.tabs").append('<li><a id="national_forums" href="#"><span>' + STRINGS['NATIONAL_PAGES_AND_FORUMS'] + '</span></a></li>');
        $j("a#national_forums").click(function() { addNationalForums() });
    }
    
    $j("ul.tabs").append('<li><a id="erep_plus_settings" href="#"><span>' + STRINGS['PLUS_SETTINGS'] + '</span></a></li>');
    $j("a#erep_plus_settings").click(function(){addeRepPlusSettings()});
    
    var p = erepPlusSettings.getValue(erepPlusSettings.TOOLS_TABS);
    if(p!=undefined)
    {
        if(erepPlusSettings.getSetting(2)=='1')
        {
            if(p == TOOLS[2])
                addThirdPartyTools();
            else if(p == TOOLS[3])
                addNationalForums();
        }
        
        if(p == TOOLS[4])
            addeRepPlusSettings();
    }
}

function addAllCommentsAndTranslate()
{
    var commentLink = '';
    var allCommentsLink = '';
    var linkArray = null;
    
    var translated = '';
    var arrToTranslate = null;
    
    var tr = null;

    $j("div.articlecontent div.largepadded a.dotted").each(function(i)
    {
        commentLink = $j(this).attr('href');
        numOfComments = $j(this).text().match(/(\d+)\D+/)[1];
        if(numOfComments > 20)	{
            linkArray = commentLink.split('/');
            linkArray[5] = 'all';
            allCommentsLink = linkArray.join('/');
            $j(this).after('<a class="dotted" href="' + allCommentsLink + '">' + STRINGS['_ALL_'] + '</a>');
        }
        
        var langTranslate = erepPlusSettings.getValue(erepPlusSettings.TRANSLATE_LANG);
        if(langTranslate == undefined)
            langTranslate = 'en';
        
        var langString = '';
        languages.forEach(function(p2)
        {
            if(langTranslate == p2.s)
            {
                langString = p2.l;
                return false;
            }
        });
        
        $j(this).parent().append('<span class="rightbordered"> </span>');
        $j(this).parent().append('<span id="translate_news_'+i+'_loader"><img src=/images/parts/ajax-loader.gif alt="" title="">&nbsp;' + STRINGS['TRANSLATING'] + '&nbsp;</span>');
        $j(this).parent().append('<a class="dotted" id="translate_news_' + i + '" href="#">' + STRINGS['TRANSLATE_TO'] + '' + langString + '</a>');
        
        $j("#translate_news_" + i + "_loader").hide();
        $j("#translate_news_" + i).each(function(i, el)
        {
            var fun = function()
            {
                $j("#translate_news_" + i + "_loader").show();
                $j("#translate_news_" + i).text(STRINGS['UNDO_TRANSLATE']);
                el.removeEventListener('click', fun, false);
                $j("#translate_news_" + i).click(function(){location.reload();});
                var art = $j("div.article div.articlecontent")[i];
                var com = $j("#comments_div")[i];
                tr = new Translator(doTranslate);
                tr.sync = false;
                if(art)
                    tr.traverse(art);
                if(com)
                    tr.traverse(com);
                $j("#translate_news_" + i + "_loader").hide();
            };
            el.addEventListener('click', fun, false);
        });
    });
}

function artGetCurrentSelection(obj)
{
    return (obj.value.substring(obj.selectionStart, obj.selectionEnd));
}

function artUpdateTextarea(object, wrapped)
{
    var len = object.value.length;
    var scrollTop = object.scrollTop;
    var scrollLeft = object.scrollLeft;
    object.value = object.value.substring(0, object.selectionStart) + wrapped + object.value.substring(object.selectionEnd, len);
    object.scrollTop = scrollTop;
    object.scrollLeft = scrollLeft;
}

function artAddAtrr(attr, checker)
{
    var object = document.getElementById('body');
    var attrValue = null;
    if(typeof(checker)!='function')
        checker = function(x){return x;};
    do
    {
        attrValue = prompt(STRINGS['PLEASE_ENTER'] + attr + ': ');
        if(attrValue==null)
            return;
        attrValue = checker(attrValue);
    }while(attrValue == '');
    
    if(attrValue != null)
    {
        var wrapped = "[" + attr + "=" + attrValue + "]" + artGetCurrentSelection(object)  + "[/" + attr + "]";
        artUpdateTextarea(object, wrapped);
    }
}

function artAddStyle(styleTag)
{
    var object = document.getElementById('body');
    var wrapped = "["+ styleTag + "]" + artGetCurrentSelection(object) + "[/" + styleTag + "]";
    artUpdateTextarea(object, wrapped);
}

function addArticleButtons()
{
    if(typeof $j("textarea#body") != undefined)
    {
        $j("#show_link").css('display', 'none');
        $j("#add_bold").css('display', 'none');
        
        $j("#link_input").css("visibility", "hidden");
        $j("#add_link").css("visibility", "hidden");
        $j("#add_link").after("<br/>");

        $j("#add_bold").after(imageButton);
        $j("#add_bold").after(sizeButton);
        $j("#add_bold").after(underlineButton);
        $j("#add_bold").after(italicButton);
        $j("#add_bold").after(boldButton);
        $j("#add_bold").after(linkButton);
        
        $j("#add_link2").click(function(){artAddAtrr('url')});
        $j("#add_bold2").click(function(){artAddStyle('b')});
        $j("#add_italic").click(function(){artAddStyle('i')});
        $j("#add_underline").click(function(){artAddStyle('u')});
        $j("#add_size").click(function(){artAddAtrr('size', function(x){var tmp = parseInt(x, 10); if(isNaN(tmp)) return ''; return tmp;})});
        $j("#add_image").click(function(){artAddStyle('img')});
    }
}

function calcTomorrowWellness()
{
    if($j("div.xprank").text() == 'Or')
        return;
    
    if($j("#owninv").length == 0)
    {
        $j("#user_menu").append('<li><a href="' + location.href.replace(/profile/, 'donate/list') + '">' + STRINGS['ALL_DONATIONS'] + '</a></li>');
        return;
    }
        
    var maxFoodQ = 0;
    var foodQ = 0;
    var maxHouseQ = 0;
    var houseQ = 0;
    var wellChange = 0;
    var wellness = $j("#wellnessvalue").text().trim();
    var style = "cursor: default; padding: 3px 3px 3px 3px; height: 15px; width: 63px; text-align:center; float: left; font-size: 12px; font-weight: bold; color: #FFF; background-color: ";
    
    $j("li[id^='personalitem']:has(img[src $=\'food.gif\']) span span").each(function(i)
    {
        foodQ = $j(this).css("width").replace(/\D+/, '') / 20;
        if(foodQ > maxFoodQ)
            maxFoodQ = foodQ;
    });
    
    $j("li[id^='personalitem']:has(img[src$=\'house.gif\']) span span").each(function(i)
    {
        houseQ = $j(this).css("width").replace(/\D+/, '') / 20;
        if(houseQ > maxHouseQ)
            maxHouseQ = houseQ;
    });
    
    if(maxFoodQ == 0)
    {
        if(wellness > 0 && wellness <= 10)
            wellChange = -1;
        else if(wellness > 10 && wellness <= 50)
            wellChange = -2;
        else if(wellness > 50 && wellness <= 80)
            wellChange = -3;
        else if(wellness > 80 && wellness <= 100)
            wellChange = -4;
    }
    else
    {
        wellChange = Math.round((1.5 - (wellness/100)) * (maxFoodQ + maxHouseQ) * 100) / 100;
    }
    
    if(wellChange < 0)
        style += "#F64846;";
    else if(wellChange == 0)
        style += "#43B7ED;";
    else if(wellChange < 2)
        style += "#FFE749; color: #000000;"
    else
        style += "#5FAE34;";

    tomorrowWellness = parseFloat(wellness) + parseFloat(wellChange);
    tomorrowWellness = Math.round(tomorrowWellness * 100) / 100;

    if(parseFloat(tomorrowWellness) > 100)
        tomorrowWellness = '100 (!)';
    
    $j("#wellnessvalue").after('<div title="' + wellChange + '" style="'+ style + '">' + tomorrowWellness + '</div>');

    var foodCalcHtml = "";
    for(var i=1; i<=5; i++)
    {
        wellChange = Math.round((1.5 - (wellness/100)) * (i + maxHouseQ) * 100) / 100;
        tomorrowWellness = parseFloat(wellness) + parseFloat(wellChange);
        tomorrowWellness = Math.round(tomorrowWellness * 100) / 100;
        if(parseFloat(tomorrowWellness) > 100)
            tomorrowWellness = '100 (!)';
        foodCalcHtml += '<div title="' + wellChange + '" style="'+ style + 'background-color: white; font-weight: normal;"><a href="/' + LOCALE + 'market/country-0-industry-' + INDUSTRIES.indexOf('Food') + '-quality-' + i + '">' + 'q' + i + ': ' + tomorrowWellness + '</a></div>';
    }
    
    foodCalcHtml = '<div id="food_wellness" style="float: left; display: none;">' + foodCalcHtml + '</div>';
    $j("#wellnessvalue").after(foodCalcHtml);
    $j("#wellnessvalue").click(function(){ $j('#food_wellness').slideToggle("fast");});
    $j("#wellnessvalue").css("cursor", "pointer");
}

function showInteractiveMap()
{
    var countryName = $j("#profileholder p:eq(1) a:eq(0)").attr("href").split('/')[4];
    var htmlMap = '<a href="#" onclick="javascript:window.open(\''; 
    htmlMap += MAP_URL + countryName.replace(/-/, '_');
    htmlMap += '\',\'mywindow\',\'location=0,status=0,scrollbars=1,fullscreen=1\');" title="" class="vroundbtnh25-start rightpadded">';
    htmlMap += '<span class="vroundbtnh25-end"><span class="vroundbtnh25-core_large"> Interactive Map </span></span></a>';
    $j("#profileholder p:eq(1)").css("width", "500px");
    $j("#profileholder p:eq(1) a:eq(1)").addClass('rightpadded');
    $j("#profileholder p:eq(1)").append(htmlMap);
}

function showQuickLinks()
{
    $j("head").append('<link rel="stylesheet" type="text/css" href="data:text/css,'+encodeURIComponent('\
    li.quick_links a {width: 85px !important; height: auto !important; float: left; background-color: #E9F5FA; padding: 5px 5px 5px 5px !important;} \
    li.quick_links a:hover {width: 85px !important; float: left; color: white; background-color: #53B3D3; padding: 5px 5px 5px 5px !important; } \
    li.quick_links_empty a {width: 85px !important; height: auto !important; float: left; cursor: default; background-color: #E9F5FA; padding: 5px 5px 5px 5px !important; } \
    li.quick_links_empty a:hover {width: 85px !important; float: left; cursor: default; background-color: #E9F5FA; padding: 5px 5px 5px 5px !important; } \
    ')+'">');

    var htmlQuickLinks = '<ul style="height: auto !important;" id="erepplus_quick_links">';
    
    for(var i=0; i<10; i++)
    {
        var currentLinkURL = erepPlusSettings.getQuickLink(i, 1);
        
        if(currentLinkURL == '')
        {
            htmlQuickLinks += '<li class="quick_links_empty"><a href="#">&nbsp;</a></li>';
        }
        else
        {
            var currentLinkNAME = erepPlusSettings.getQuickLink(i, 0);
            if(currentLinkURL.substr(0, 11) == 'javascript:')
                htmlQuickLinks += '<li class="quick_links"><a href="#" onclick="' + currentLinkURL + '">' + currentLinkNAME + '</a></li>';
            else
                if(erepPlusSettings.getQuickLink(i, 2) == '1')
                    htmlQuickLinks += '<li class="quick_links"><a href="' + currentLinkURL + '" target="_blank">' + currentLinkNAME + '</a></li>';
                else
                    htmlQuickLinks += '<li class="quick_links"><a href="' + currentLinkURL + '">' + currentLinkNAME + '</a></li>';
        }
    }
    htmlQuickLinks += '</ul>';
    $j("#menu").append(htmlQuickLinks);
}

function displayError(msg)
{
    if(msg.length == 0)
        msg = 'Unknown error';
        
    if($j("#erepplus_error_frame").length == 0)
    {
        $j("#menu").after('<div id="erepplus_error_frame"></div>');
        $j("head").append('<link rel="stylesheet" type="text/css" href="data:text/css,'+encodeURIComponent('\
        .erepplus_error {margin: 5px 5px 5px 5px !important;} \
        .erepplus_error:hover {background-color: #CC0000; color: #FFFFFF;} \
        .erepplus_error_frame {background-color: #FFCCCC !important; float: left; clear: both !important; width: 100%; margin: 0px 0px 0px 0px} \
        ')+'">');
    }
    
    $j("#erepplus_error_frame").show();
    $j("#erepplus_error_frame").addClass("erepplus_error_frame");
    $j("#erepplus_error_frame").append('<div class="erepplus_error">Error: '+msg+'</div>');
    $j(".erepplus_error").click(function()
    {
        $j(this).hide("slow", function()
        {
            if($j(".erepplus_error:visible").length == 0)
            {
                $j("#erepplus_error_frame").hide();
                $j("#erepplus_error_frame").removeClass("erepplus_error_frame");
            }
        });
        return true;
    });
}

function showCountryHospitals()
{
    var countryName = $j("#profileholder p:eq(1) a:eq(0)").attr("href").split('/')[4];
    var sCountriesReq = "http://api.erepublik.com/v1/feeds/countries.json";
    var sCountryReq = "http://api.erepublik.com/v1/feeds/countries/";
    var sRegionReq = "http://api.erepublik.com/v1/feeds/regions/";
    $j("table.regions tr th:eq(0)").after('<th></th><th width="150"></th>');
    //displayError("test error");
    erepPlusUtils.xmlHttpRequest(
    {
        method: 'GET',
        operaHack: true,
        url: sCountriesReq,
        onload: function(json)
        {
            try
            {
                eval("tempList = " + json.responseText);
            }
            catch(e)
            {
                return;
            }
            for(var ia = 0; ia < tempList.length; ia++) {
                var val = tempList[ia];
                if(countryName == val["permalink"]) {
                    erepPlusUtils.xmlHttpRequest(
                    {
                        method: 'GET',
                        operaHack: true,
                        url: sCountryReq + val["id"] + ".json",
                        onload: function(json)
                        {
                            try
                            {
                                eval("tempList = " + json.responseText);
                            }
                            catch(e)
                            {
                                return;
                            }
                            var strHtml = new Array();
                            for(var i = 0; i < tempList["regions"].length; i++)
                            {
                                var val = tempList["regions"][i];
                                erepPlusUtils.xmlHttpRequest({
                                    method: 'GET',
                                    operaHack: true,
                                    url: sRegionReq + val["id"] + ".json",
                                    onload: function (json)
                                    {
                                        opera.postError(sRegionReq + val["id"] + ".json");
                                        try
                                        {
                                            eval("tempList = " + json.responseText);
                                        }
                                        catch(e)
                                        {
                                            return;
                                        }
                                        strHtml[i] = "<td><img src='/images/parts/icon_industry_hospital.gif' style='float: left;'/></td><td>";
                                        if(tempList["constructions"] != null)
                                        {
                                            $j.each(tempList["constructions"], function(j, val) {
                                                if(val["name"] == "hospital")
                                                    strHtml[i] += '<span class="qlmeter" style="float: left;"><span class="qllevel" style="width: ' + (val["quality"] * 20) + '%;"><img src="/images/parts/ql-indicator_full.gif" alt="Quality Level" title="Quality"></span></span>';
                                                else if(tempList["constructions"].length == 1)
                                                    strHtml[i] += '<span class="qlmeter"><span class="qllevel" style="width: 0%;"><img src="/images/parts/ql-indicator_full.gif" alt="Quality Level" title="Quality"></span></span>';										
                                            });
                                        }
                                        else
                                            strHtml[i] += '<span class="qlmeter"><span class="qllevel" style="width: 0%;"><img src="/images/parts/ql-indicator_full.gif" alt="Quality Level" title="Quality"></span></span>';										
                                        strHtml[i] += "</td>";
                                        $j("table.regions").find("a.fakeheight[href='/" + LOCALE + "region/" + tempList["permalink"] + "']").css("float", "left");
                                        $j("table.regions").find("a.fakeheight[href='/" + LOCALE + "region/" + tempList["permalink"] + "']").css("text-height", "55px");
                                        $j("table.regions").find("td:has(a.fakeheight[href='/" + LOCALE + "region/" + tempList["permalink"] + "'])").after(strHtml[i]);
                                    }
                                });
                            }
                        }
                    });
                    return false;
                }
            }
        }
    });
}

function calcNextSSMedal()
{
    var Strength = parseFloat($j('img[src $= "icon_skill_strenght.gif"]').parent().text());
    var trainingsNeeded = 0;
    var nextStrength = (Math.floor(Strength / 5) + 1) * 5;
    
    if(Strength >= 4) {
        trainingsNeeded = Math.floor((nextStrength - Strength) / 0.04);
        if(((trainingsNeeded * 0.04) + Strength) < nextStrength)
            trainingsNeeded++;
    }
    else if(Strength >= 3 && Strength < 4)	{
        trainingsNeeded = 25 + Math.floor((4 - Strength) / 0.1);
        if(((trainingsNeeded * 0.2) + Strength + 25) < nextStrength)
            trainingsNeeded++;
    }
    else if(Strength >= 2 && Strength < 3) {
        trainingsNeeded = 35 + Math.floor((3 - Strength) / 0.2);
        if(((trainingsNeeded * 0.1) + Strength + 35) < nextStrength)
            trainingsNeeded++;
    }
    else if(Strength >= 1 && Strength < 2)	{
        trainingsNeeded = 40 + Math.floor((2 - Strength) / 0.5);
        if(((trainingsNeeded * 0.5) + Strength + 40) < nextStrength)
            trainingsNeeded++;
    }
    $j('#achievment li:eq(6) span p:eq(1)').append(".<br/>" + STRINGS['TRAININGS_TO_NEXT_MEDAL'] + "<strong>" + trainingsNeeded + "</strong>");
}

function addBattleStats()
{
    //var battleID = location.href.substr(location.href.lastIndexOf('/') + 1);
    //$j("div.defender:eq(0)").append('<ul class="profilemenu"><li><a class="goright" target="_blank" href="http://neatbattlestats.net16.net/showbattle.php?id=' + battleID + '">' + STRINGS['STATS'] + '</a></li></ul>');
}

function showPlayersLinksOnBattlefield()
{
    $j("div.fighter div.nameholder:not(:has(a))").each(function(i, el)
    {
        var c = $j(this);
        var po = c.text().trim();
        var p = po;
        if(p.length > 12)
            p = p.substr(0, 12);
        var playerLink = '<a href="http://www.erepublik.com/en/search/?q='+encodeURIComponent(p)+'&commit=" target="_blank">'+po+'</a>';
        c.html(playerLink);
    });
    setTimeout(showPlayersLinksOnBattlefield, 1500);
}

function Main(e)
{
    // disable on error pages
    if($j("div.errtxt").length > 0)
        return;
        
    $j("#logo a").append(plusImage);
    $j("#logo a").attr("title", "eRepublik Plus v" + VERSION);
        
    // just logo on login page
    if($j("div#loginbox").length > 0)
        return;
        
    try
    {
        cID = $j("div.core div.avatarholder a").attr("href").split('/')[4] + "_";
    }
    catch(e)
    {
    }
    
    erepPlusUtils = erepPlusUtilsInit();
    erepPlusSettings = new erepPlusSettingsInit(cID);
    
    if(typeof(opera.postError)=='function' && erepPlusSettings.getDebugSettings()=='1')
        debug = opera.postError;
    else
        debug = function() {};
    
    if(typeof unsafeWindow == 'undefined')
        unsafeWindow = window;
    
    var subURL = currURL.substr(BASE_URL.length);
    LOCALE = subURL.substring(0, 2) + '/';
    BASE_URL += LOCALE;
    subURL = currURL.substr(BASE_URL.length);

    if(erepPlusSettings.getSetting(12) == '1')
        window.setTimeout(showQuickLinks, 0);

    $j("#nav").ready(function()
    {
        if(erepPlusSettings.getSetting(10) == '1')
            updateSavedLinks();
    });    

    var pagesFunctions = [
        {p: 'my-places/army',               s:5,    f: showPotentialDamage},
        {p: 'human-resources/',             s:6,    f: addJobMarketLinks},
        {p: 'human-resources/',             s:15,   f: addSalaryInGold},
        {p: 'news/',                        s:1,    f: addNewsTitle},
        {p: 'exchange',                     s:7,    f: fixMonetaryMarket},
        {p: 'company-employees/',           s:9,    f: showEmployeeMessageAndGifts},
        {p: 'company-employees/',           s:17,   f: showEmployeeSalariesInGold},
        {p: 'write-article',                s:4,    f: addArticleButtons},
        {p: 'edit-article/',                s:4,    f: addArticleButtons},
        {p: 'forum',                        s:4,    f: addArticleButtons},
        {p: 'market/',                      s:8,    f: showUnitPrice},
        {p: 'market/',                      s:15,   f: showMarketPricesInGold},
        {p: 'badges',                       s:-1,   f: modifyTools},
        {p: 'rss_menu',                     s:-1,   f: modifyTools},
        {p: 'article/',                     s:0,    f: addAllCommentsAndTranslate},
        {p: 'newspaper/',                   s:0,    f: addAllCommentsAndTranslate},
        {p: 'citizen/profile/',             s:3,    f: calcTomorrowWellness},
        {p: 'citizen/profile/',             s:14,   f: calcNextSSMedal},
        {p: 'country/\\w+$',                s:13,   f: showCountryHospitals},
        {p: 'country',                      s:11,   f: showInteractiveMap},
        {p: 'battles/show/',                s:18,   f: showPlayersLinksOnBattlefield},
        {p: 'citizen/donate/items/',        s:16,   f: enableQuickDonate},
        {p: 'company/\\d+/donate/items',    s:16,   f: enableQuickDonate},
        {p: 'organization/donate/items/',   s:16,   f: enableQuickDonate},
    ];
    
    pagesFunctions.forEach(function(v)
    {
        var re = new RegExp("^" + v.p)
        if((re.test(subURL)) && (erepPlusSettings.getSetting(v.s) != '0' || v.s == '-1'))
        {
            debug('Main(): page matched: '+currURL+' (via '+re.source+')');
            v.f();
        }
    });
};

window.addEventListener('load', function()
{
    if(typeof(jQuery)=='undefined')
        return;
    $j = jQuery;
    Main();
}, false);


// Utils
function erepPlusUtilsInit()
{
    var DEFAULT_TIMEOUT = 30000;
    
    function ResponseState()
    {
        this.responseXML = '';
        this.responseText = '';
        this.readyState = '';
        this.responseHeader = '';
        this.status = '';
        this.statusText = '';
    }
    
    var x = 0;
    
    return {
        xmlHttpRequest: function(details, timeout, async) // greasemonkey style-based
        {
            if(!details)
                return;
            debug('XHR: Issuing request to '+details.url)
            // set onerror if needed
            if(!details["onerror"])
            {
                details.onerror = function(responseState, request)
                {        
                    displayError('['+responseState.status+']:' + request.url + ': '+ responseState.statusText);
                }
            }
            
            if(!async)
                async = true;
                
            if(!timeout)
                timeout = DEFAULT_TIMEOUT;
            
            // --
            
            var xhr;
            var xhrTimeout;
            
            if(typeof(opera.XMLHttpRequest)=='function' && typeof(details["operaHack"])=='boolean' && details["operaHack"]==true)
                xhr = new opera.XMLHttpRequest(); // Opera modified version
            else
                xhr = new XMLHttpRequest();

            try
            {
                xhr.onreadystatechange = function()
                {
                    var response = new ResponseState();
                    response.readyState = xhr.readyState;
                    
                    if(response.readyState==4)
                    {
                        response.responseXML = xhr.responseXML;
                        response.responseText = xhr.responseText;
                        response.responseHeaders = xhr.getAllResponseHeaders();
                        response.status = xhr.status;
                        response.statusText = xhr.statusText;
                    }                  
                    if(details["onreadystatechange"])
                        details["onreadystatechange"](responseState, details);
                        
                    if(response.readyState!=4)
                        return;
                        
                    clearTimeout(xhrTimeout);
                    if(typeof(details["operaHack"])=='boolean' && details["operaHack"]==true)
                    {
                        $j("iframe").each(function(i, el)
                        {
                            if(el.src.substr(0, details.url.length) == details.url)
                            {
                                debug('XHR: removing iframe ('+el.src+', '+el.id+')');
                                el.parentNode.removeChild(el);
                                return false;
                            }
                        });
                    }
                    
                    if(details["onload"] && response.status>=200 && response.status<300)
                        details["onload"](response, details);
                    if(details["onerror"] && (response.status<200 || response.status>=300))
                        details["onerror"](response, details);
                }
                
                xhr.open(details.method, details.url, async);
                
                if(details["headers"])
                {
                    for(var prop in details.headers)
                    {
                        xhr.setRequestHeader(prop, details.headers[prop]);
                    }
                }
                
                xhr.send((details.data)?details.data:null);
                
                xhrTimeout = setTimeout(function()
                {
                    if(xhr.readyState==4)
                        return;
                    xhr.onreadystatechange = function(){};
                    xhr.abort();
                    debug('XHR: Request to '+details.url+' timed out');
                    if(typeof(details["operaHack"])=='boolean' && details["operaHack"]==true)
                    {
                        $j("iframe").each(function(i, el)
                        {
                            if(el.src.substr(0, details.url.length) == details.url)
                            {
                                el.src = 'about:blank'; // should work, at least if we don't request the same page multiple times
                                return false;
                            }
                        });
                    }
                    if(details["onerror"])
                    {
                       response = new ResponseState();
                       response.status = 503;
                       response.statusText = 'Connection timed out.';
                       details["onerror"](response, details);
                    }
                }, timeout);
            }
            catch(e)
            {
                if(details["onerror"])
                {
                    response = new ResponseState();
                    response.status = 503;
                    response.statusText = e.message;
                    details["onerror"](response, details);
                }
            }
        },
        //IDEA make width configurable and allow choosing display style
        formatGoldValue: function(gold)
        {
            var tmp = '';
            var out = '';
            try
            {
                tmp = gold.toFixed(4); // <--
            }
            catch(e)
            {
                tmp = gold.toString();
            }
            
            var s = tmp.split('.');
            
            if(s[1] == undefined)
                s[1] = '';
            else
                s[1] = '.' + s[1];
            
            return '<span class="special">' + s[0] + '</span><sup>' + s[1] + '</sup> \
                <span class="currency">&nbsp;<img title="Gold" alt="Gold" src="/images/parts/icon-gold.gif"/></span>';
        },
    };
}

// Settings
function erepPlusSettingsInit(cID)
{
    var SAVED_LINKS =
    {
        LINK_MARKET        : 'eRmRM',
        LINK_MON_MARKET    : 'eRmMM',
        LINK_JOB_MARKET    : 'eRmJM',
        LINK_COM_MARKET    : 'eRmCM',
        LINK_RANKINGS      : 'eRmRa',
        LINK_COUNTRY       : 'eRmCo',
        LINK_COUNTRY_ECO   : 'eRmCe',
        LINK_COUNTRY_POL   : 'eRmCp',
        LINK_COUNTRY_MIL   : 'eRmCm',
        LINK_ELECTIONS     : 'eRmEl',
        LINK_TOOLS         : 'eRmTo',
        LINK_NEWS          : 'eRmNe',
    };
    
    var CONF =
    {
        QUICK_LINKS        : 'eRmQL',
        TOOLS_TABS         : 'eRmT2',
        TRANSLATE_LANG     : 'eRmLG',
        DONATE_PUTSIZE     : 'eRmPS',
        SETTINGS           : 'eRmSe',
    };
    
    var QUICK_LINKS_FIELDS =
    {
        MIN_VAL: -1,
        NAME: 0,
        ADDRESS: 1,
        NEW_WINDOW: 2,
        MAX_VAL: 3
    };
    
    
    // ---
    for(k in SAVED_LINKS)
        this[k] = SAVED_LINKS[k];
    for(k in CONF)
        this[k] = CONF[k];
    
    var DEFAULT_SETTINGS = "FFFFFFFFFF";
    //var DEFAULT_SETTINGS = "1111111111111111111111";
    var DEFAULT_LINKS =
    [
        'Link 1', '', '0',
        'Link 2', '', '0',
        'Link 3', '', '0',
        'Link 4', '', '0',
        'Link 5', '', '0',
        'Link 6', '', '0',
        'Link 7', '', '0',
        'Link 8', '', '0',
        'Support eRep+', BASE_URL + 'citizen/donate/items/1408159', '0',
        'eRepublik Plus', BASE_URL + 'newspaper/erepublik-plus-187657/1', '0'
    ];
    var cID = cID;
    
    if(typeof(Prototype)!='object')
        throw new Error('Prototype missing');

    this.getValue = function(n)
    {
        if(n==undefined)
            throw new Error('get undefined');
        if(!n)
            return;
            
        var tmp = document.cookie.match(new RegExp(escape(cID+n) + "=([^;]+)"));
        
        if(!tmp)
            return undefined;

        var k = unescape(tmp[1]);
        return k.evalJSON(true);
    };
    this.setValue = function(n, v) // setting to null means deleting
    {
        if(n==undefined)
            throw new Error('set undefined');

        var lifeTime = new Date();
        if(v==null)
            lifeTime.setFullYear(1970, 0, 1);
        else
            lifeTime.setFullYear(new Date().getFullYear()+10);

        var k = Object.toJSON(v);
        document.cookie = escape(cID+n) + "=" + escape(k) + "; expires=" + lifeTime.toGMTString() + "; path=/;"
        
        if(v==null) // to assure deletion
            this.getValue(n);
    };
    this.getSetting = function(id)
    {
        var tmp = this.getValue(this.SETTINGS);
        if(tmp == undefined)
            return '1';

        try
        {
            var s = parseInt(tmp, 16);
            return ((s & (1<<id))>0);
        }
        catch(ex)
        {
            debug('getSetting failed: '+tmp);
        }
        return '0';
    };
    this.setSetting = function(id, v)
    {
        var tmp = this.getValue(this.SETTINGS);
        if(tmp == undefined)
            tmp = DEFAULT_SETTINGS;

        try
        {
            var s = parseInt(tmp, 16);
            var mask = (1<<id);
            if(v>0) // set
                s |= mask;
            else // clear
                s &= ~mask;
            this.setValue(this.SETTINGS, s.toString(16));
        }
        catch(ex)
        {
            debug('setSetting failed: '+tmp);
        }
    };
    this.getQuickLink = function(i, j)
    {
        if(j>=QUICK_LINKS_FIELDS.MAX_VAL || j<=QUICK_LINKS_FIELDS.MIN_VAL)
        {
            debug('getQuickLink(): j out of range, defaulting to NAME');
            j=QUICK_LINKS_FIELDS.NAME;
        }
        
        var tmp = this.getValue(this.QUICK_LINKS);
        if(tmp == undefined)
            tmp = DEFAULT_LINKS.slice();
            
        return tmp[i*3+j];
    };
    this.setQuickLink = function(obj, j)
    {
        var tmp = this.getValue(this.QUICK_LINKS);
        if(tmp == undefined)
            tmp = DEFAULT_LINKS.slice();
        
        var i = obj.id.split('_')[2];
        if(j == QUICK_LINKS_FIELDS.NEW_WINDOW)
            tmp[i*3+j] = (obj.checked)?'1':'0';
        else
            tmp[i*3+j] = obj.value.replace(/[\r\v\n]/, '');

        this.setValue(this.QUICK_LINKS, tmp);
    };
    this.resetQuickLinks = function()
    {
        this.setValue(this.QUICK_LINKS, DEFAULT_LINKS);
    };
    this.resetSavedLinks = function()
    {
        for(k in SAVED_LINKS)
            this.setValue(SAVED_LINKS[k], null);
    };
    this.reset = function()
    {
        this.resetQuickLinks();
        this.resetSavedLinks();
        this.setValue(this.TRANSLATE_LANG, 'en');
        this.setValue(this.SETTINGS, DEFAULT_SETTINGS);
    };
    this.export = function()
    {
        var ex = {SL: {}, CF: {}};
        for(k in SAVED_LINKS)
            ex.SL[k] = this.getValue(SAVED_LINKS[k]);

        for(k in CONF)
            ex.CF[k] = this.getValue(CONF[k]);
            
        return Object.toJSON(ex);
    };
    this.import = function(data)
    {
        try
        {
            var ex = data.evalJSON(true);
            for(k in SAVED_LINKS)
            {
                if(ex.SL[k]!=undefined)
                    this.setValue(SAVED_LINKS[k], ex.SL[k]);
            }
            
            for(k in CONF)
            {
                if(ex.CF[k]!=undefined)
                    this.setValue(CONF[k], ex.CF[k]);
            }
            
            return true;
        }
        catch(e)
        {
            return false;
        }
    };
    this.getDebugSettings = function()
    {
        return '0';
    }
}

/**
* Translator
* Copyright (c) 2008 Ariel Flesler - aflesler(at)gmail(dot)com | http://flesler.blogspot.com
* Licensed under BSD (http://www.opensource.org/licenses/bsd-license.php)
* Date: 5/26/2008
*
* @projectDescription JS Class to translate text nodes.
* @author Ariel Flesler
* @version 1.0.1
*/

/**
* The constructor must receive the parsing function, which will get the text as parameter
* To use it, call the method .traverse() on the starting (root) node.
* If the parsing is asynchronous (f.e AJAX), set sync to false on the instance.
* When doing so, the parser function receives an extra argument, which is a function
* that must be called passing it the parsed text.
*/

function Translator( parser, filter ){
    this.parse = parser; // function that parses the original string
    this.filter = filter; // optional filtering function that receives the node, and returns true/false
};
Translator.prototype = {
    translate:function( old ){ // translates a text node
        if(this.sync )
            this.replace( old, this.parse(old.nodeValue) );
        else{
            var self = this;
            this.parse( old.nodeValue, function( text ){
                self.replace( old, text );
            });
        }
    },
    makeNode:function( data ){
        if(data && data.split ) // replacing for a string
            data = document.createTextNode(data);
        return data;
    },
    replace:function( old, text ){ // Replaces a text node with a new (string) text or another node
        if(text != null && text != old.nodeValue ){
            var parent = old.parentNode;
            if(text.splice ){ // Array
                for( var i = 0, l = text.length - 1; i < l; )
                    parent.insertBefore( this.makeNode(text[i++]), old );
                text = this.makeNode(text[l] || ''); // Last
            }else
                text = this.makeNode(text);
            parent.replaceChild( text, old );
        }
    },
    valid:/\S/, // Used to skip empty text nodes (modify at your own risk)
    sync:true, // If the parsing requires a callback, set to false
    traverse:function( root ){ // Goes (recursively) thru the text nodes of the root, translating
        var children = root.childNodes,
            l = children.length,
            c = children.length,
            node;
        
        while( l-- ){
            node = children[c - l - 1];
            if(node.nodeType == 3 ){ // Text node
                if(this.valid.test(node.nodeValue) ) // Skip empty text nodes
                    this.translate( node );
            }else if(node.nodeType == 1 && (!this.filter || this.filter(node)) ) // Element node
                this.traverse( node );
        }
    }
};

function doTranslate(text, replace)
{
    var strArray = new Array();
    var arr = text.split(" ");
    var str500 = '';
    for(var i = 0;i<arr.length; i++)
    {
        arr[i] = encodeURIComponent(arr[i]);
        if(str500.length + arr[i].length < 497)
        {
            str500 += '%20'  + arr[i];
            if(i == arr.length - 1)
                strArray.push(str500);
        }
        else
        {
            strArray.push(str500);
            str500 = arr[i];
        }
    }
    
    var langTranslate = erepPlusSettings.getValue(erepPlusSettings.TRANSLATE_LANG);
    if(langTranslate == undefined)
        langTranslate = 'en';
    
    doRequest(strArray, 0, 0, replace, langTranslate);
}

function doRequest(arr, i, count, rep, lang)
{
    if(arr[i] == undefined)
        return;
        
    erepPlusUtils.xmlHttpRequest(
    {
        method: 'GET',
        operaHack: true,
        url: 'http://ajax.googleapis.com/ajax/services/language/translate?v=1.0&langpair=%7C' + lang + '&q=' + arr[i],
        onload: function(response)
        {
            try
            {
                eval('var jsonObj = (' + decodeURIComponent(response.responseText.replace(/%/g, "%25")) + ')');
            }
            catch(e)
            {
                return;
            }

            if(jsonObj["responseData"] != null)
                arr[i] = ' ' + ((jsonObj["responseData"]["translatedText"])) + ' ';
            else
                arr[i] = ' ';
                
            count++;

            if(count < arr.length) {
                doRequest(arr, i + 1, count, rep, lang);
            }
            else {
                rep(decodeHTMLEntities(arr.join(' ')));
            }		
        },
        onerror: function() {}
    }, 60000);
}

function decodeHTMLEntities(strToDecode)
{
    var entities =
    [
        {e: /&quot;/g,	r: '"'},
        {e: /&apos;/g,	r: "'"},
        {e: /&gt;/g,	r: ">"},
        {e: /&lt;/g,	r: "<"},
        {e: /&#39;/g,	r: "'"},
        {e: /&amp;/g,	r: '&'}
    ];
    
    entities.forEach(function(p)
    {
        strToDecode = strToDecode.replace(p.e, p.r);
    });
    
    return strToDecode;
}

// =============================================================================================================
//     Version        Date            Change Log
//  0.59 OpMod  3 Dec 2009      - Modified for Opera.
//                              - New Features:
//                              1)  Additional color to indicate wellness change between 0 and +2 points.
//                              2)  Option to export/imports/reset settings.
//                              3)  New API errors/timeouts handling.
//                              4)  Links to 'Search Citizen' on citizens' names on Battle Page.
//                              5)  Added fast items loading and clearing donation list on Donation Page.
//                              6)  Added salary in gold on employees details page (for non-owner)
//
//                              - Updates:
//                              1)  Adjusted gold formatting.
//                              2)  Translate option now show target language.
//                              3)  Disabling Erepublik Plus OpMod on error/mainteance pages (fully) and login page (only logo)
//                              4)  Updated logo
//
//                              - Fixes:
//                              1)  Fixed 'Swap' image on MM page.
//                              2)  Disabling showing unit prices doesn't disable showing price in gold anymore.
//                              3)  Disallow entering non-numeric values into size field in article/forum editor.
//
//  0.58        7 Oct 2009      - HotFix release: Changed URL mask to cover for different eRep URLs
//                                
//  0.57        6 Oct 2009      - New Features:
//                              1)  Advanced wellness calculator (now shows tomorrow wellness for all q of food)
//                              2)  Added links to all donations and fights on player profile page
//                              3)  Added send message and offer gift to all employees page
//                              4)  Added Neat Battle Stats to Third Party Tools
//                              5)  Added link to stats on Battle Page
//                              6)  Added full damage to Army page
//
//                              - Updates:
//                              1)  Added Turkey and Slovakia national forums
//                              2)  Updated Estonia, Russia, Singapore national forum
//
//
//  0.56        01 Sep 2009     - New Features:
//                              1)  Added calculation of market prices and salaries in gold
//
//                              - Updates:
//                              1) Added Ukraine Forum
//                              2) Updated forum URLs for Canada and Iran
//
//                              - Fixes:
//                              1)  Translations now work in Opera too
//                              2)  Fixed issue with News in Opera
//                              3)  Fixed issue with translation of multiple articles on newspaper page
//
//
//  0.55        21 Aug 2009     - Fixes:
//                              1)  Changed url of jQuery library (now it is part of Google API)
//
//                              - Updates:            
//                              1)  Changed URLs of the following Pages: Bolivia, Canada, Colombia
//                              2)  Added URL of South African and Chinese official forums
//
//
//  0.54        10 Jul 2009     - Fixes:
//                              1)  Fixed serious defect with donations under Opera
//
//
//  0.53        10 Jul 2009     - New Features:
//                              1)  Added Trainings till next Super Soldier medal Feature
//                              2)  Added Quality of Hospital in Social Stats Feature
//                              - Updates:
//                              1)  Added India and Japan official forum links
//                              2)  Redesigned code for easier localization
//                              3)  Updated Italian official forum link
//                              4)  Code changes to support Opera browser
//
//
//  0.52        10 Jun 2009     - Updates:
//                              1)  Added links to following National Pages and Forums:
//                                  Mexico, Chile, Venezuela, Argentina, Colombia, Peru, 
//                                  Uruguay, Paraguay, Bolivia and Philippines
//                              2)  Cleaner code for Damage in Army code
//                              3)  Minor tweaks to support Spanish version of eRepublik
//                              4)  Added 'Reset saved links' button in Plus Settings
//                              5)  Fixed MM defect when currency offer was made by company
//
//
//  0.51        02 Jun 2009     - New features:
//                              1)  Added Interactive Map Feature
//                              2)  Added Quick Links Feature
//                              3)  Added Bulgaria, Russia and Singapore forum links
//                              4)  Started adoption to support future Spanish version of eRepublik
//
//                              - Fixes:
//                              1)  Fixed URL of Spanish Forum
//
//
//  0.50        01 Jun 2009     - New Features:
//                              1)  Added eRepublik Plus Settings 
//                                  (from now on you can turn eRepublik features on and off)  
//                              2)  Added translation support for OVER 40 languages
//                              3)  Added erepTools logo
//                              4)  Expanded Unit price to all products in Marketplace
//                              5)  Added forum of Bosnia and Herzegovina
//
//                              - Fixes:
//                              1)  Cosmetic bug with spaces after and before bb tags in translations is fixed now
//
//
//  0.42        29 May 2009     - New Features:
//                              1)  eRepublik Plus is now able to translate newspaper
//                                  articles to english. Comments also included into
//                                  translation process.
//
//                              - Fixes:
//                              1)  Fixed bug with Save Links when used under Organization account
//                              2)  Fixed bug with Save Links on Monetary Market. Now it remembers
//                                  your last combination of currencies when these are changed using
//                                  selectors
//                              3)  From now on, citizen and organization(s) accounts do not share 
//                                  same Saved Links, these are entirely separated
//                              4)  Changed the way of signaling that your wellness will exceed 100
//                              5)  Fixed minor bug with wellness calculator, it attempted to
//                                  calculate wellness for Organizations :), now fixed
//
//
//  0.41        26 May 2009     - Updates & Fixes:
//                              1)  Added logo to Third Party Tools for two tools 
//                              2)  Added eSerbia and eIsraeli Forums to National Pages and Forums
//                              3)  Fixed minor bug with wellness rounding
//                              4)  Fixed bug with wrong calculation of wellness when more houses 
//                                  or foods with various Q were in inventory
//
//
//  0.40        25 May 2009     - New features release
//                              1)  Rudimental wellness calculator (shows tomorrow's wellness)
//                              2)  Tools got 'Third Party Tools' and 'National Forums' tabs
//                              3)  'All comments' link to show all the comments in Newspaper
//
//
//  0.31        23 May 2009     - Bug fixes release:
//                              1)  Removed functionality of 'Update' button in Monetary market
//                                  as it does not make any sense any longer. There was an non-announced 
//                                  change to eRepublik base code and from now on, you can delete or update
//                                  your offer only after 5 minutes elapsed. This change caused bug in 
//                                  eRepublik Plus so that your offer was deleted after 5 minutes but new one
//                                  was not posted. All of that functionality is now gone. 
//
//
//  0.30        21 May 2009     - New features release:
//                              1)  Calculates and shows unit price of raw materials 
//                                  (price per quality level)
//                              2)  Article editor now available for forum posts too.
//                              3)  Article editor rewritten from scratch to avoid ugly
//                                  functions overrides and to be less 'jumpy'.
//
//  0.21        18 May 2009     - Bug fixes release (thanks to those who reported)
//                              1)  When new article created, buttons were not shown, now fixed
//
//
//  0.20        18 May 2009     - New features release:
//                              1)  Added buttons to help edit newspapers
//                              2)  When you put your pointer over the eRepublik Logo, 
//                                  version of eRepublik Plus is shown (this is to help you
//                                  find out what version you are using)
//
//
//  0.12        16 May 2009     - Bug fixes release (Again, thanks to those who reported it :))  
//                              1)  Save Links made more robust to avoid some quirks
//                              2)  Added version meta tag to the script so you know what version
//                                  you have installed
//
//
//  0.11        16 May 2009     - Bug fixes release (Thanks to those who reported defects :))
//                              1)  Field Marshals had incorrectly calculated damage, now fixed
//                              2)  7+ working skills were not correctly filtered, now fixed
//
//
//  0.10        15 May 2009     - Initial release with the following features:
//                              1)  Links are preserved for Marketplace, Monetary market, Job market,
//                                  Companies for sale, Rankings, Social, Economic, Political and    
//                                  Military stats, Elections, News and Tools
//                              2)  All Employees page shows wellness of each employee
//                              3)  Army page calculates and displays damage done with various quality
//                                  level of weapon. Click on Quality stars shows local Marketpace offer
//                                  for that quality level.
//                              4)  Monetary market has added 'Swap currencies' feature as well as Update offer
//                              5)  Job market page has added links to quickly filter offer 
//                                  by Skill type and Skill value
//                              6)  News page shows type of news (latest, top ranked...)
//                              7)  Added Plus icon near eRepublik logo when eRepublik Plus script is active
